import { cos } from "mathjs";

 //定义变量储存div的宽高
 var obj_w, obj_h;
 //定义一个变量判断是否执行移动函数
 var mouseDown = false;
export default {
    data() {
        return {
            /**  多选  */
            selectList: [],
            selectTabelList: [],
            multipleSelection_1: []
        }
    },
    methods: {
        //鼠标按下函数
        downDiv(obj) {
            //获取div的宽高
            obj_w = obj.offsetWidth;
            obj_h = obj.offsetHeight;
            //鼠标
            var e = event || window.event;
            //e.clientX/Y 是获取鼠标相对浏览器的位置；将div中心自动居中到鼠标
           
            let left = (e.clientX - obj_w / 2) + "px";
            let top = (e.clientY - obj_h / 2) + "px";
            console.log('鼠标按下===',mouseDown,left, top)
            //按下时为ture,松开时为false，以判断是否执行执行mouveDiv
            mouseDown = true;
        
        },
        
        //鼠标移动函数
        moveDiv(obj) {
            obj_w = obj.offsetWidth;
            obj_h = obj.offsetHeight;
            var e = event || window.event;
            // console.log(e.clientX, e.clientY);
            // console.log(obj_w, obj_h);
            if (mouseDown) {
                obj.style.left = (e.clientX - obj_w / 2) + "px";
                obj.style.top = (e.clientY - obj_h / 2) + "px";
                console.log('鼠标移动===',obj.style.left, obj.style.top)
            }
        
        },
        
        //鼠标松开函数
        upDiv(obj) {
            mouseDown = false;
            console.log('鼠标鼠标所开===',mouseDown)
        },

        /**  当前选择  开始   */
        /**  多选  */
        dragSelectChange(e){
            console.log("e===",e)
            if(e && e.div) {
                let  list = JSON.parse(JSON.stringify(e.div))
                this.selectList = [...new Set(list)]
                console.log("e===",this.selectList)
                if(this.activeName=='select'){
                    this.addSelectTabelList()
                }
            }
            
        },
        dragLostItemChange(e){
            console.log("最后一个===",e)
        },
        reSelect(e) {
            console.log("reSelect===",e)
        },
        addSelectTabelList(){
            if(this.selectList && this.selectList.length > 0) {
                let listTabel = []
                for(let i=0;i<this.selectList.length;i++){
                    for(let j=0;j<this.tableDataAll.length;j++){

                        if(this.selectList[i] == this.tableDataAll[j].styleCss.id){
                            listTabel.push({
                                ...this.tableDataAll[j],
                            })
                            break;
                        }    
                    }
                }
                console.log("listTabel=====",listTabel)
                this.selectTabelList = JSON.parse(JSON.stringify(listTabel))
            }else { 
                this.selectTabelList = []
            }
        },
        //  清除已选
        delSelectTabelList(){
            this.selectList = []
            this.selectTabelList = []
        },
        /**  当前选择  结束   */

        /**  批量修改   */

        // 座位状态
        selectBatchSetaDisableFun() {
            let listTabel = JSON.parse(JSON.stringify(this.tableDataAll))
            for(let i=0;i<this.selectTabelList.length;i++){
                for(let j=0;j<this.tableDataAll.length;j++){
                    if(this.selectTabelList[i].styleCss.id == this.tableDataAll[j].styleCss.id){
                        listTabel[j] = {
                            ...this.tableDataAll[j],
                            status: this.formAll.status,
                        }
                        break;
                    }    
                }
            }
            this.tableDataAll = JSON.parse(JSON.stringify(listTabel))
            console.log("this.tableDataAll=====",this.tableDataAll)
            // this.batchTableList = JSON.parse(JSON.stringify(this.tableDataAll))
            this.formDialogVisible = false
            this.handleQuery()
            this.dataProcess()
        },
        //批量修改座位类型 
        selectBatchSetaTypeFun() {
            let color = ''
            let seatLabel = ''
            let listTabel = JSON.parse(JSON.stringify(this.tableDataAll))
            this.seatTypeList.forEach((item,index)=>{
                if(this.formAll.seatTypeId == item.id) {
                    color = item.color
                    seatLabel = item.name 
                }
            })
            for(let i=0;i<this.selectTabelList.length;i++){
                for(let j=0;j<this.tableDataAll.length;j++){
                    if(this.selectTabelList[i].styleCss.id == this.tableDataAll[j].styleCss.id){
                        listTabel[j] = {
                            ...this.tableDataAll[j],
                            seatLabel: seatLabel,
                            color: color,// 座位类型对应的颜色
                            seatTypeId: this.formAll.seatTypeId,
                        }
                        break;
                    }    
                }
            }
            this.tableDataAll = JSON.parse(JSON.stringify(listTabel))
            console.log("this.tableDataAll=====",this.tableDataAll)
            // this.batchTableList = JSON.parse(JSON.stringify(this.tableDataAll))
            this.formDialogVisible = false
            this.dataProcess()
            this.addSelectTabelList()
        },  
        // 批量修改名称
        selectBatchSetaNameFun() {
            if(this.formAll.seatWay == 1){ // 相同的
                let listTabel = JSON.parse(JSON.stringify(this.tableDataAll))
                for(let i=0;i<this.selectTabelList.length;i++){
                    for(let j=0;j<this.tableDataAll.length;j++){
                        if(this.selectTabelList[i].styleCss.id == this.tableDataAll[j].styleCss.id){
                            listTabel[j] = {
                                ...this.tableDataAll[j],
                                name: this.formAll.name
                            }
                            break;
                        }    
                    }
                }
                this.tableDataAll = JSON.parse(JSON.stringify(listTabel))
            }else if(this.formAll.seatWay == 2){
                let name = (this.formAll.name1?this.formAll.name1:'') + '${row}' + (this.formAll.name?this.formAll.name:'') + '${col}' + (this.formAll.name2?this.formAll.name2:'')
                let listTabel = JSON.parse(JSON.stringify(this.tableDataAll))
                for(let i=0;i<this.selectTabelList.length;i++){
                    for(let j=0;j<this.tableDataAll.length;j++){
                        if(this.selectTabelList[i].styleCss.id == this.tableDataAll[j].styleCss.id){
                            listTabel[j] = {
                                ...this.tableDataAll[j],
                                name: name.replace('${row}',this.tableDataAll[j].rowNo).replace('${col}',this.tableDataAll[j].columnNo)
                            }
                            break;
                        }    
                    }
                }
                this.tableDataAll = JSON.parse(JSON.stringify(listTabel))
            }
            this.formDialogVisible = false
            this.dataProcess()
            this.addSelectTabelList()
        },
        // 批量修改优先级
        selectBatchSetaPriorityFun(){
            if(this.formAll.seatPriorityWay == 1){
                let listTabel = JSON.parse(JSON.stringify(this.tableDataAll))
                for(let i=0;i<this.selectTabelList.length;i++){
                    for(let j=0;j<this.tableDataAll.length;j++){
                        if(this.selectTabelList[i].styleCss.id == this.tableDataAll[j].styleCss.id){
                            listTabel[j] = {
                                ...this.tableDataAll[j],
                                priority: this.formAll.setaPriorityNum
                            }
                            break;
                        }    
                    }
                }
                this.tableDataAll = JSON.parse(JSON.stringify(listTabel))
            }else{
                let listTabel = JSON.parse(JSON.stringify(this.tableDataAll))
                let listSelect = JSON.parse(JSON.stringify(this.selectTabelList))
                if(this.formAll.seatPriorityPosition == 2) {
                    listSelect.reverse()
                }
                console.log("fsafsdfa=====",listSelect)
                let num = Number(this.formAll.setaPriorityNum)
                for(let i=0;i<listSelect.length;i++){
                    for(let j=0;j<this.tableDataAll.length;j++){
                        if(listSelect[i].styleCss.id == this.tableDataAll[j].styleCss.id){
                            listTabel[j] = {
                                ...this.tableDataAll[j],
                                priority: num
                            }
                            if(this.formAll.seatPriorityWay == 2){
                                num = num + 1
                            }else if(this.formAll.seatPriorityWay == 3){
                                num = num - 1
                            }
                            break;
                        }    
                    }
                }
                this.tableDataAll = JSON.parse(JSON.stringify(listTabel))
            }
            this.formDialogVisible = false
            this.dataProcess()
            this.addSelectTabelList()
        },
    },
}